
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include <uf.h>
#include <uf_defs.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_styler.h>
#include <uf_mb.h> 
#include <oratypes.h>
#include <ocidfn.h>
#include <ocidem.h>
#include <ociapr.h>
#include "struct_mat.h"
#include "color_metal.h"

extern int COUNTER_SORTAMENT;
extern text *uid1;
extern int kod[];
extern text names[][MAX_NAME_LENGTH];
extern sb2 ind_oboz, ind_kod;
/*   OCI- */
extern Lda_Def lda;
extern ub1 hda[256];
extern Cda_Def cda;

int oci_error(Cda_Def *cda);

#define CHANGE_CB_COUNT ( 3 + 1 ) /* Add 1 for the terminator */


static UF_STYLER_callback_info_t CHANGE_cbs[CHANGE_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, CHANGE_constructor},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, CHANGE_press_ok},
 {CHANGE_BUTTON_1       , UF_STYLER_ACTIVATE_CB     , 1, CHANGE_press_button1},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};



static UF_MB_styler_actions_t actions[] = {
    { "color_metal.dlg",  NULL,   CHANGE_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};


void color_metal (char *str1)
{
    int  response   = 0;
    int  error_code = 0;
 
    if ( ( UF_initialize() ) != 0 ) 
           return;

    strcpy(CATEGORIA1,str1);

    if ( ( error_code = UF_STYLER_create_dialog ( "color_metal.dlg",
           CHANGE_cbs,      /* Callbacks from dialog */
           CHANGE_CB_COUNT, /* number of callbacks*/
           NULL,        /* This is your client data */
           &response ) ) != 0 )
    {
          char fail_message[133];

          /* Get the user function fail message based on the fail code.*/
          UF_get_fail_message(error_code, fail_message);
          UF_UI_set_status (fail_message);
          printf ( "%s\n", fail_message ); 
    }


    UF_terminate();                             
    return;
}




int CHANGE_constructor ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	long count, i;
	char Uslovie[300];

     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

	strcpy(Uslovie,"select count(*) from (select naim from st_kl where kl='");
	strcat(Uslovie,CATEGORIA1);
	strcat(Uslovie,"' and length(naim)>0 group by naim)");

  if (olog(&lda, hda, uid1, -1, 0, -1, 0, -1, OCI_LM_DEF))
  {
      UF_UI_open_listing_window();
      UF_UI_write_listing_window("\ncannot connect to Oracle as ");
	  UF_UI_write_listing_window(uid1);
      UF_terminate ();
      return ( UF_UI_CB_EXIT_DIALOG );
  }

  if (oopen(&cda, &lda, 0, -1, -1, 0, -1))
  {
      UF_UI_open_listing_window();
      UF_UI_write_listing_window("cannot open the cursor\n");
      ologof(&lda);
      return ( UF_UI_CB_EXIT_DIALOG );
  }

  if (oparse(&cda, (text*) Uslovie, -1, 1, 2))
  {
    oci_error(&cda);
    return ( UF_UI_CB_EXIT_DIALOG );
  }

  if (odefin(&cda, 1, (int*) kod, (int) sizeof (int), SQLT_INT, -1, 
             0, 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return ( UF_UI_CB_EXIT_DIALOG );
  }

  if (oexec(&cda))
  {    
	oci_error(&cda);
    return ( UF_UI_CB_EXIT_DIALOG );
  }


  ofen(&cda, 1);
  count=kod[0];
  oclose(&cda);
  
  oopen(&cda, &lda, 0, -1, -1, 0, -1);

	memset(Uslovie, ' ', 200);

	strcpy(Uslovie,"select naim from st_kl where (kl='");
	strcat(Uslovie,CATEGORIA1);
	strcat(Uslovie,"' and length(naim)>0) group by naim order by naim");

	UF_UI_write_listing_window("\n");
	UF_UI_write_listing_window(Uslovie);

	if (oparse(&cda, (text*) Uslovie, -1, 1, 2))
  {
    oci_error(&cda);
    return ( UF_UI_CB_EXIT_DIALOG );
  }

 if (odefin(&cda, 1, &names[0][0], MAX_NAME_LENGTH, SQLT_STR, -1, 
             0, 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return ( UF_UI_CB_EXIT_DIALOG );
  }



  if (oexec(&cda))
  {    
	oci_error(&cda);
    return ( UF_UI_CB_EXIT_DIALOG );
  }

 
  ofen(&cda, count);

  COUNTER_SORTAMENT=count;
  list_sortament=(struct MATERIALS**) malloc(sizeof(struct MATERIALS*)*count);
  callback_data->value.strings=(char **) malloc(sizeof(char*)*count);

	 for (i=0;i<count;i++)
	 {
		 char oboz[MAX_NAME_LENGTH];
		 int n_kl;
		 strcpy(oboz, (char *) names[i]);
		 n_kl=kod[i];
		 

		 /*    */
		 list_sortament[i]=(struct MATERIALS*) malloc(sizeof(struct MATERIALS));
		 list_sortament[i]->cod=(int) n_kl;
		 strcpy(list_sortament[i]->name,(const char *) oboz);


		 /*       ST_KL */
		 callback_data->value.strings[i]=(char *) malloc(MAX_NAME_LENGTH); 
		 strcpy(callback_data->value.strings[i], (const char *) oboz);
	 }


	 callback_data->item_id=(char *) malloc(sizeof(char)*15);
	 strcpy((char *) callback_data->item_id,"LIST_1");
	 callback_data->item_attr=UF_STYLER_SUBITEM_VALUES;
	 callback_data->count=count;
	 UF_STYLER_set_value (dialog_id, callback_data);
 
     oclose(&cda);
     ologof(&lda);


     UF_terminate ();

     return (UF_UI_CB_CONTINUE_DIALOG); 

}


int CHANGE_press_ok ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */  
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a ok callback.*/
    /* return ( UF_UI_CB_EXIT_DIALOG );                    */
    return (UF_UI_CB_CONTINUE_DIALOG);                           

}


int CHANGE_press_button1 ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */  
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     callback_data->item_id=(char *) malloc(sizeof(char)*15);
	 strcpy((char *) callback_data->item_id,"LIST_1");
	 callback_data->item_attr=UF_STYLER_VALUE;
	 callback_data->indicator=UF_STYLER_STRING_VALUE;
     UF_STYLER_ask_value (dialog_id,callback_data);

	 /*     */
     if (callback_data->count==0)   
	 {
	     UF_terminate ();
         return (UF_UI_CB_CONTINUE_DIALOG);    
	 }


	 sel_black_metal (callback_data->value.string,"naim");
     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_EXIT_DIALOG); 
    
    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}

int oci_error(Cda_Def *cda)
{
  UF_UI_write_listing_window("\nOracle ERROR\n");
  return 0;
}

