
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include <uf.h>
#include <uf_defs.h>
#include <uf_exit.h> 
#include <uf_ui.h>
#include <uf_styler.h>
#include <uf_mb.h>
#include <oratypes.h>
#include <ocidfn.h>
#include <ocidem.h>
#include <ociapr.h>
#include "struct_mat.h"     /*    */
#include "sel_black_met.h"


void send_sortament_to_list(int, UF_STYLER_item_value_type_p_t);
extern int oci_error(Cda_Def *cda);

extern int COUNTER_SORTAMENT;
extern text *uid1;
extern int kod[];
extern text names[][MAX_NAME_LENGTH];
extern ub2 rl[], rc[];
extern sb2 ind_oboz, ind_kod;
/*   OCI- */
extern Lda_Def lda;
extern ub1 hda[256];
extern Cda_Def cda;

extern int COUNTER_SORTAMENT;
extern text *uid1;


#define CHANGE_CB_COUNT ( 3 + 1 ) /* Add 1 for the terminator */

 
static UF_STYLER_callback_info_t CHANGE_cbs[CHANGE_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, CHANGE_sel_mat_constructor},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, CHANGE_button_ok2},
 {CHANGE_BUTTON_1       , UF_STYLER_ACTIVATE_CB     , 1, CHANGE_press_button_2},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};



static UF_MB_styler_actions_t actions[] = {
    { "sel_black_met.dlg",  NULL,   CHANGE_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};



void sel_black_metal (char * Uslovie, char *find_field)
{
    int  response   = 0;
    int  error_code = 0;
 
    if ( ( UF_initialize() ) != 0 ) 
           return;


	 memset(CATEGORIA,' ',200);
	 strcpy(CATEGORIA, Uslovie);
	 memset(FIND_FIELD,' ',200);
	 strcpy(FIND_FIELD, find_field);


    if ( ( error_code = UF_STYLER_create_dialog ( "sel_black_met.dlg",
           CHANGE_cbs,     
           CHANGE_CB_COUNT,
           NULL,        
           &response ) ) != 0 )
    {
          char fail_message[133];

          UF_get_fail_message(error_code, fail_message);
          UF_UI_set_status (fail_message);
          printf ( "%s\n", fail_message ); 
    }


    UF_terminate();                             
    return;
}



int CHANGE_sel_mat_constructor ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{

    if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

    /* ------     --------- */
    send_sortament_to_list( dialog_id, callback_data);


    UF_terminate ();
    return (UF_UI_CB_CONTINUE_DIALOG); 

}


/* -------------------------------------------------------------------------
 * Callback Name: CHANGE_button_ok
 * This is a callback function associated with an action taken from a
 * UIStyler object. 
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s) 
 *                               UF_STYLER_set_value   
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.                 
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that  
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int CHANGE_button_ok2 ( int dialog_id,
             void *client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */  
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a ok callback.*/
    /* return ( UF_UI_CB_EXIT_DIALOG );                    */
    return (UF_UI_CB_CONTINUE_DIALOG);                           

}


/* -------------------------------------------------------------------------
 * Callback Name: CHANGE_press_button_1
 * This is a callback function associated with an action taken from a
 * UIStyler object. 
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s) 
 *                               UF_STYLER_set_value   
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.                 
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that  
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int CHANGE_press_button_2 ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	int i;

     /* Make sure User Function is available. */  
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
	
 /* ----       -------- */

	 strcpy((char *) callback_data->item_id, "MULTI_LIST_1");
	 callback_data->item_attr = UF_STYLER_VALUE;
	 callback_data->indicator = UF_STYLER_INTEGER_PTR_VALUE;
     UF_STYLER_ask_value (dialog_id, callback_data);

	 COUNTER_INDEX = callback_data->count;
	 
	 /*     */
	 if (COUNTER_INDEX == 0)   
	 {
	     UF_terminate ();
         return (UF_UI_CB_CONTINUE_DIALOG);    
	 }

	 sortament_index=(int *) malloc( sizeof(int) * callback_data->count );

     /* -----      -----*/
	 for(i = 0; i < callback_data->count; i++)
		 sortament_index[i] = callback_data->value.integers[i];

     select_material ();

     UF_terminate ();

    return (UF_UI_CB_EXIT_DIALOG);    

}



void send_sortament_to_list( int dialog_id, UF_STYLER_item_value_type_p_t callback_data)
{
	long count, i;
	char Uslovie[200];

	strcpy(Uslovie, "select count(*) from st_kl where ");
	strcat(Uslovie, FIND_FIELD);
	strcat(Uslovie, "='");
	strcat(Uslovie, CATEGORIA);
	strcat(Uslovie, "' and length(rtrim(naim1))>0");


  if (olog(&lda, hda, uid1, -1, 0, -1, 0, -1, OCI_LM_DEF))
  {
      UF_UI_open_listing_window();
	  UF_UI_write_listing_window("\ncannot connect to Oracle as");
	  UF_UI_write_listing_window(uid1);
      UF_terminate ();
      return;
  }

  if (oopen(&cda, &lda, 0, -1, -1, 0, -1))
  {
      UF_UI_open_listing_window();
      UF_UI_write_listing_window("cannot open the cursor\n");
      ologof(&lda);
      return;
  }

  if (oparse(&cda, (text*) Uslovie, -1, 1, 2))
  {
    oci_error(&cda);
    return;
  }

  if (odefin(&cda, 1, (int*) kod, (int) sizeof (int), SQLT_INT, -1, 
             0, 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return;
  }

  if (oexec(&cda))
  {    
	oci_error(&cda);
    return;
  }


  ofen(&cda, 1);
  count = kod[0];
  oclose(&cda);


    oopen(&cda, &lda, 0, -1, -1, 0, -1);
	memset(Uslovie, ' ', 200);

	strcpy(Uslovie, "select rtrim(naim1), n_kl from st_kl where (");
	strcat(Uslovie, FIND_FIELD);
	strcat(Uslovie, "='");
	strcat(Uslovie, CATEGORIA);
	strcat(Uslovie, "' and length(rtrim(naim1))>0) order by naim1");

  if (oparse(&cda, (text*) Uslovie, -1, 1, 2))
  {
    oci_error(&cda);
    return;
  }

 if (odefin(&cda, 1, &names[0][0], MAX_NAME_LENGTH, SQLT_STR, -1, 
             0, 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return;
  }

 if (odefin(&cda, 2, (int*) kod, (int) sizeof (int), SQLT_INT, -1, 
             0, 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return;
  }

  if (oexec(&cda))
  {    
	oci_error(&cda);
    return;
  }
 
  ofen(&cda, count);
  COUNTER_SORTAMENT = count;

	list_sortament = (struct MATERIALS**) malloc(sizeof(struct MATERIALS*)*count);
     callback_data->value.strings = (char **) malloc(sizeof(char*)*count);
	 for (i = 0; i < count; i++)
	 {
		 char oboz[MAX_NAME_LENGTH];
		 int n_kl;
		 strcpy(oboz, (char *) names[i]);
		 n_kl=kod[i];

		 /*    */
		 list_sortament[i] = (struct MATERIALS*) malloc(sizeof(struct MATERIALS));
		 list_sortament[i]->cod = (int) n_kl;
		 strcpy(list_sortament[i]->name, (const char *) oboz);

		 /*       ST_KL */
		 callback_data->value.strings[i] = (char *) malloc(MAX_NAME_LENGTH); 
		 strcpy(callback_data->value.strings[i], (const char *) oboz);
	 }

	 callback_data->item_id = (char *) malloc( sizeof(char) * 15 );
	 strcpy((char *) callback_data->item_id, "MULTI_LIST_1");
	 callback_data->item_attr = UF_STYLER_SUBITEM_VALUES;
	 callback_data->count = count;
	 UF_STYLER_set_value (dialog_id, callback_data);


  oclose(&cda);
  ologof(&lda);

 return;

}




