
#include <stdio.h> 
#include <string.h> 
#include <malloc.h>
#include <uf.h>
#include <uf_defs.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_sf.h>
#include <uf_styler.h>
#include <uf_mb.h> 
#include <uf_object_types.h>
#include <uf_attr.h>
#include <uf_assem.h>
#include <uf_modl.h>
#include <oratypes.h>
#include <ocidfn.h>
#include <ocidem.h>
#include <ociapr.h>
#include "sel_material.h"
#include "struct_mat.h"


extern tag_t part_tag;
extern int COUNTER_SORTAMENT;
extern text *uid1;
extern int kod[];
extern text names[][MAX_NAME_LENGTH+35+2], names1[][MAX_NAME_LENGTH];
extern text gabarit[][35];
extern float ud[];
extern ub2 ind_kod[], ind_names[], ind_gabarit[], ind_ud[], ind_names1[];

//   OCI- 
extern Lda_Def lda;
extern ub1 hda[256];
extern Cda_Def cda;



int oci_error(Cda_Def *cda);


#define CHANGE_CB_COUNT ( 3 + 1 ) /* Add 1 for the terminator */
 
static UF_STYLER_callback_info_t CHANGE_cbs[CHANGE_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, CHANGE_sel_material},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, CHANGE_button_ok1},
 {CHANGE_BUTTON_1       , UF_STYLER_ACTIVATE_CB     , 0, CHANGE_press_button_1},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};


static UF_MB_styler_actions_t actions[] = {
    { "sel_material.dlg",  NULL,   CHANGE_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};


void select_material ()
{
    int  response   = 0;
    int  error_code = 0;
 
    if ( ( UF_initialize() ) != 0 ) 
           return;

    if ( ( error_code = UF_STYLER_create_dialog ( "sel_material.dlg",
           CHANGE_cbs,      /* Callbacks from dialog */
           CHANGE_CB_COUNT, /* number of callbacks*/
           NULL,        /* This is your client data */
           &response ) ) != 0 )
    {
          char fail_message[133];

          /* Get the user function fail message based on the fail code.*/
          UF_get_fail_message(error_code, fail_message);
          UF_UI_set_status (fail_message);
          printf ( "%s\n", fail_message ); 
    }


    UF_terminate();                             
    return;
}




int CHANGE_sel_material ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	long count, i;
	char buff[5];
	char Uslovie[2000];


     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

	strcpy(Uslovie, "select count(*) from (select aa1 from (select (rtrim(oboz) || ' ' || rtrim(gabarit)) as aa1 from matstd ");
	strcpy(PodUslovie, " where (");
	for (i = 0; i < COUNTER_INDEX; i++)
	{
		strcat(PodUslovie, " (n_kl=");
		sprintf(buff, "%d", list_sortament[sortament_index[i]]->cod);
		strcat(PodUslovie, buff);
		strcat(PodUslovie, " and rtrim(obz)='");
		strcat(PodUslovie, list_sortament[sortament_index[i]]->name);
		strcat(PodUslovie, "') or");
	}
    PodUslovie[strlen(PodUslovie)-3] = ')';
    PodUslovie[strlen(PodUslovie)-2] = '\0';
    
    strcat(Uslovie, PodUslovie);
	strcat(Uslovie, "))");


	if (olog(&lda, hda, uid1, -1, 0, -1, 0, -1, OCI_LM_DEF))
  {
	  UF_UI_open_listing_window();
      UF_UI_write_listing_window("\ncannot connect to Oracle as ");
      UF_UI_write_listing_window(uid1);
      UF_terminate();
      return 1;
  }

  if (oopen(&cda, &lda, 0, -1, -1, 0, -1))
  {
      UF_UI_open_listing_window();
      UF_UI_write_listing_window("cannot open the cursor\n");
      ologof(&lda);
      return 1;
  }

  if (oparse(&cda, (text*) Uslovie, -1, 1, 2))
  {
    oci_error(&cda);
    return 1;
  }

  if (odefin(&cda, 1, (int*) kod, (int) sizeof (int), SQLT_INT, -1, 
             &ind_kod[0], 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return 1;
  }

  if (oexec(&cda))
  {    
	oci_error(&cda);
    return 1;
  }


  ofen(&cda, 1);
  count=kod[0];
  oclose(&cda);



  oopen(&cda, &lda, 0, -1, -1, 0, -1);
  memset(Uslovie, ' ', 2000);

  strcpy(Uslovie, "select rtrim(oboz), rtrim(gabarit), ud from matstd");
  strcat(Uslovie, PodUslovie);
  strcat(Uslovie, " and length(oboz)>0 order by oboz");

  if (oparse(&cda, (text*) Uslovie, -1, 1, 2))
  {
    oci_error(&cda);
    return 1;
  }

 if (odefin(&cda, 1, &names[0][0], MAX_NAME_LENGTH+35+2, SQLT_STR, -1, 
             &ind_names[0], 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return 1;
  }

 if (odefin(&cda, 2, &gabarit[0][0], 35, SQLT_STR, -1, 
             &ind_gabarit[0], 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return 1;
  }

 if (odefin(&cda, 3, &ud[0], (int) sizeof(float), SQLT_FLT, -1,
             &ind_ud[0], 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return 1;
  }


 if (oexec(&cda))
  {    
	oci_error(&cda);
    return 1;
  }

  ofen(&cda, count);


	 COUNTER_MATERIAL = count;
     list_mat = (struct MATERIALS**) malloc( sizeof(struct MATERIALS*) * count );

     callback_data->value.strings = (char **) malloc( sizeof(char*) * count );
	 for (i = 0; i < count; i++)
	 {
		 char oboz[MAX_NAME_LENGTH + 35 + 2];
		 strcpy(oboz, (char *) names[i]);
		 strcat(oboz, " ");
		 if (gabarit[i] != NULL) strcat(oboz, (char *) gabarit[i]);

		 /*    */
		 list_mat[i] = (struct MATERIALS*) malloc(sizeof(struct MATERIALS));
		 strcpy(list_mat[i]->name, (const char *) oboz);
		 strcpy(list_mat[i]->short_name, (const char *) names[i]);
		 list_mat[i]->ud_ves = ud[i];

		  /*       MATSTD :  OBOZ+VSPXR */
		 callback_data->value.strings[i] = (char *) malloc(MAX_NAME_LENGTH + 35 + 2);
		 strcpy(callback_data->value.strings[i], (const char *) oboz);
	 }

	 callback_data->item_id = (char *) malloc( sizeof(char) * 15 );
	 strcpy((char *) callback_data->item_id, "LIST_1");
	 callback_data->item_attr = UF_STYLER_SUBITEM_VALUES;
	 callback_data->count = count;
	 UF_STYLER_set_value (dialog_id, callback_data);


  oclose(&cda);
  ologof(&lda);
	      	 
  UF_terminate ();

  return (UF_UI_CB_CONTINUE_DIALOG); 

}




int CHANGE_button_ok1 ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     int i;
	 char buff[100];
	 double density;
	 tag_t object;

    /* ------      ------- */ 
     callback_data->item_id = (char *) malloc( sizeof(char) * 15 );
 	 strcpy((char *) callback_data->item_id, "LIST_1");
	 callback_data->item_attr = UF_STYLER_VALUE;
	 callback_data->indicator = UF_STYLER_INTEGER_VALUE;
     UF_STYLER_ask_value (dialog_id, callback_data);

	 /*      */
	 if (callback_data->count!=1) return(UF_UI_CB_CONTINUE_DIALOG);

	UF_UI_open_listing_window();
	UF_UI_write_listing_window("\n   UGPART    :");

     nnn.type = UF_ATTR_string;
	 nnn.value.string = list_mat[callback_data->value.integer]->short_name;
	 UF_ATTR_assign (part_tag, "MATERIAL", nnn);
	 UF_UI_write_listing_window("\n   MATERIAL = ");
	 UF_UI_write_listing_window(nnn.value. string);  


	 /*    */
	 object = NULL_TAG;
     UF_MODL_ask_object (UF_solid_type, 0, &object );
	 if ( object != NULL_TAG )
	 {
		 density = list_mat[callback_data->value.integer]->ud_ves;
		 UF_MODL_set_body_density(object, UF_MODL_grams_centimeters, density);
         sprintf(buff, "%15.12f", density);
		 UF_UI_write_listing_window("\n   SOLID DENSITY = ");
		 UF_UI_write_listing_window(buff);
	 }
	 else
	    UF_UI_write_listing_window("\n     SOLID_BODY,  SOLID DENSITY  ");

	/* ------   ---------- */
	 if ( COUNTER_INDEX > 0 ) free(sortament_index);
	 if ( COUNTER_MATERIAL > 0 )
		 for (i = 0; i < COUNTER_MATERIAL; i++)
			 free(list_mat[i]); 
	 
/*	 if (COUNTER_SORTAMENT>0)

		 for (i=0;i<COUNTER_SORTAMENT;i++);
			 free(list_sortament[i]);

*/

    return (UF_UI_CB_EXIT_DIALOG);                           

}




int CHANGE_press_button_1 ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{

	long count, i;
	char Uslovie[2000];


     /* ---- Enter your callback code here ----- */

     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

    /*    */
	strcpy((char *) callback_data->item_id, "WIDE_S_1");
	callback_data->item_attr = UF_STYLER_VALUE;
	UF_STYLER_ask_value (dialog_id, callback_data);

	ChangeMask(callback_data->value.string);

/* ---------------      ----------- */

	strcpy(Uslovie, "select count(*) from (select aa1 from (select (rtrim(oboz) || ' ' || rtrim(gabarit)) as aa1 from matstd ");
    strcat(Uslovie, PodUslovie);
	strcat(Uslovie, " and length(oboz)>0))");
	strcat(Uslovie, " where aa1 like '");
    strcat(Uslovie, callback_data->value.string);
    strcat(Uslovie, "'");

  if (olog(&lda, hda, uid1, -1, 0, -1, 0, -1, OCI_LM_DEF))
  {
      UF_UI_write_listing_window("\ncannot connect to Oracle as");
      UF_UI_write_listing_window(uid1);
      UF_terminate ();
      return 1;
  }

  if (oopen(&cda, &lda, 0, -1, -1, 0, -1))
  {
      UF_UI_open_listing_window();
      UF_UI_write_listing_window("cannot open the cursor\n");
      ologof(&lda);
      return 1;
  }

  if (oparse(&cda, (text*) Uslovie, -1, 1, 2))
  {
    oci_error(&cda);
    return 1;
  }

  if (odefin(&cda, 1, (int*) kod, (int) sizeof (int), SQLT_INT, -1, 
             &ind_kod[0], 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return 1;
  }

  if (oexec(&cda))
  {    
	oci_error(&cda);
    return 1;
  }


  ofen(&cda, 1);
  count = kod[0];
  oclose(&cda);

/* ---------------   ---------------------*/
    oopen(&cda, &lda, 0, -1, -1, 0, -1);
	memset(Uslovie, ' ', 2000);

	strcpy(Uslovie, "select aa1,ud,oboz from (select (rtrim(oboz) || ' ' || rtrim(gabarit)) as aa1,ud,oboz from matstd");
	strcat(Uslovie, PodUslovie);
	strcat(Uslovie, " and length(oboz)>0)");
	strcat(Uslovie, " where aa1 like '");
	strcat(Uslovie, callback_data->value.string);
	strcat(Uslovie, "'");

  if (oparse(&cda, (text*) Uslovie, -1, 1, 2))
  {
    oci_error(&cda);
    return 1;
  }

 if (odefin(&cda, 1, &names[0][0], MAX_NAME_LENGTH+35+2, SQLT_STR, -1, 
             &ind_names[0], 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return 1;
  }

 if (odefin(&cda, 2, &ud[0], (int) sizeof(float), SQLT_FLT,-1,
             &ind_ud[0], 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return 1;
  }

 if (odefin(&cda, 3, &names1[0][0], MAX_NAME_LENGTH, SQLT_STR,-1,
             &ind_names1[0], 0, -1, -1, 0, 0))
  {    
    oci_error(&cda);
    return 1;
  }


 if (oexec(&cda))
  {    
	oci_error(&cda);
    return 1;
  }
 
  ofen(&cda, count);


	if (COUNTER_MATERIAL>0)
		 for (i=0;i<COUNTER_MATERIAL;i++)
			 free(list_mat[i]);


	 COUNTER_MATERIAL = count;
     list_mat = (struct MATERIALS**) malloc(sizeof( struct MATERIALS*) * count );

     callback_data->value.strings = (char **) malloc( sizeof(char*) * count );
	 for (i=0;i<count;i++)
	 {
		 char oboz[MAX_NAME_LENGTH+35+2];
		 strcpy(oboz, (char *) names[i]);

		 /*    */
		 list_mat[i] = (struct MATERIALS*) malloc(sizeof(struct MATERIALS));
		 strcpy(list_mat[i]->name, (const char *) oboz);
		 strcpy(list_mat[i]->short_name, (const char *) names1[i]);
		 list_mat[i]->ud_ves = ud[i];

		 /*       MATSTD */
		 callback_data->value.strings[i] = (char *) malloc(MAX_NAME_LENGTH+35+2); 
		 strcpy(callback_data->value.strings[i], (const char *) oboz);
	 }

	     callback_data->item_id = (char *) malloc(sizeof(char)*15);
		 strcpy((char *) callback_data->item_id, "LIST_1");
		 callback_data->item_attr = UF_STYLER_SUBITEM_VALUES;
		 callback_data->count = count;
	     UF_STYLER_set_value (dialog_id, callback_data);


    oclose(&cda);
    ologof(&lda);

    UF_terminate ();

    return (UF_UI_CB_CONTINUE_DIALOG); 
    

}



/* ----------     ORACLE --------- */
void ChangeMask(char *str1)
{
	int i;
	for (i=0;i<(int)strlen(str1);i++)
		if (str1[i]=='*') str1[i]='%';
}
